using LinearAlgebra.Vectors;
using LinearAlgebra.Vectors.Numeric;
using Real = System.Double;

namespace LinearAlgebra.Matrices
{
	/// <summary>
	/// Default view 
	/// </summary>
	public class RealMatrix : Vector<RealVector> {

		public RealMatrix() {}

		public RealMatrix( int numRows, int numCols ) : base( numRows ) {
			for( int i = 0; i < numRows ; i++ )			
				Add( new RealVector( numCols ) );		
		}
		
		public RealVector Add( params Real[] rowOfValues )
		{
			RealVector r = new RealVector( rowOfValues );
			Add( r );
			return r;
		}		
	}
}